//-----------------------------------------------------------------------------
// Title      : bsp_ub018_mk3_fat16
//-----------------------------------------------------------------------------
// Funktion   : SD-Card Test
// Schaltung  : myAVR MK3
//-----------------------------------------------------------------------------
// Prozessor  : ATMega2560
// Takt       : 16 MHz
// Sprache    : C
// Date       : 15.09.2010
// Version    : 1.0
// Autor      : UB
//-----------------------------------------------------------------------------
#define F_CPU 16000000
#include <avr/io.h>
#include <ub_mk3_2560/MK3_2560_LCD.h>
#include <ub_mk3_2560/MK3_2560_FAT16.h>

//-----------------------------------------------------------------------------
// Hinweis : Quick-Jumper Port-C+A muss gesetzt sein
// - testet ob eine SD-Karte eingelegt ist
// - testet ob ein File vorhanden ist
// - liest einen String aus dem File und zeigt den Text an
//-----------------------------------------------------------------------------

int main (void)
{
	bool s_ok=false;
	File *myFile;
	char puffer[20];
	
	MK3_INIT_LCD();					// init des LCD
	
	MK3_LCD_CLEAR();				// LCD loeschen
	MK3_LCD_LIGHT(true);			// beleuchtung einschalten
	
	MK3_INIT_FAT16();
	
	MK3_LCD_STRING_AT(0,0,"suche SD-Karte:");
	
	s_ok=MK3_FAT16_CHKDSK();
	
	if(s_ok==true) {
		MK3_LCD_STRING_AT(0,8,"Karte gefunden");
		if(myFile=F21_fopen_("file1.txt",'r')) {
		  F29_fgets_(&puffer[0],18,myFile);  // auslesen von 18 Zeichen
		  F22_fclose_(myFile);
		  MK3_LCD_STRING_AT(0,16,"file ausgelesen");
		  MK3_LCD_STRING_AT(0,32,puffer);
		}
		else {
		  MK3_LCD_STRING_AT(0,16,"file nicht gefunden");
		}
	}
	else {
		MK3_LCD_STRING_AT(0,8,"...keine Karte");
	}
	

	while (true)
	{
	
	}
	return 0;
}
//-----------------------------------------------------------------------------






