//-----------------------------------------------------------------------------
// Title      : bsp_ub019_mk3_fat16
//-----------------------------------------------------------------------------
// Funktion   : SD-Card Test
// Schaltung  : myAVR MK3
//-----------------------------------------------------------------------------
// Prozessor  : ATMega2560
// Takt       : 16 MHz
// Sprache    : C
// Date       : 18.09.2010
// Version    : 1.0
// Autor      : UB
//-----------------------------------------------------------------------------
#define F_CPU 16000000
#include <avr/io.h>
#include <ub_mk3_2560/MK3_2560_LCD.h>
#include <ub_mk3_2560/MK3_2560_FAT16.h>

//-----------------------------------------------------------------------------
// Hinweis : Quick-Jumper Port-C+A muss gesetzt sein
// - testet ob eine SD-Karte eingelegt ist
// - abspeichern von 3 Strukturelementen 
//-----------------------------------------------------------------------------

// struktur der Messwerte
struct daten{
  unsigned int lfd_nr;
  int messwert;
  bool fehler;
};

int main (void)
{
	bool s_ok=false;
	File *myFile;
	daten mwert[5];           // anlegen von 5 Messwerten
	
	MK3_INIT_LCD();					// init des LCD
	
	MK3_LCD_CLEAR();				// LCD loeschen
	MK3_LCD_LIGHT(true);			// beleuchtung einschalten
	
	MK3_INIT_FAT16();
	
	MK3_LCD_STRING_AT(0,0,"suche SD-Karte:");
	
	s_ok=MK3_FAT16_CHKDSK();


	// Daten mit Werten fuellen
        mwert[0].lfd_nr=1;
        mwert[0].messwert=10;
        mwert[0].fehler=false;
        mwert[1].lfd_nr=2;
        mwert[1].messwert=-5;
        mwert[1].fehler=true;
        mwert[2].lfd_nr=3;
        mwert[2].messwert=25;
        mwert[2].fehler=false;
        mwert[3].lfd_nr=4;
        mwert[3].messwert=-15;
        mwert[3].fehler=true;
        mwert[4].lfd_nr=5;
        mwert[4].messwert=30;
        mwert[4].fehler=false;
	
	if(s_ok==true) {
		MK3_LCD_STRING_AT(0,8,"Karte gefunden");
		if(myFile=F21_fopen_("messung.dat",'a')) { // daten werden angehngt
		  F24_fwrite_(mwert,sizeof(mwert),3,myFile);   // speichern von 3 Datenstze
		  F22_fclose_(myFile);
		  MK3_LCD_STRING_AT(0,16,"ok");
		  MK3_LCD_STRING_AT(0,32,"Daten gespeichert...");
		}
		else {
		  MK3_LCD_STRING_AT(0,16,"error");
		}
	}
	else {
		MK3_LCD_STRING_AT(0,8,"...keine Karte");
	}
	

	while (true)
	{
	
	}
	return 0;
}
//-----------------------------------------------------------------------------






